## mingw-w64-viskores-1.0.0-3.src.tar.zst

=== CMakeLists.txt ===
##============================================================================
##  The contents of this file are covered by the Viskores license. See
##  LICENSE.txt for details.
##
##  By contributing to this file, all contributors agree to the Developer
##  Certificate of Origin Version 1.1 (DCO 1.1) as stated in DCO.txt.
##============================================================================

##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================

cmake_minimum_required(VERSION 3.15 FATAL_ERROR)
project (Viskores)

# We only allow c++14
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# When using C++14 support make sure you use the standard C++ extensions rather
# than compiler-specific versions of the extensions (to preserve portability).
set(CMAKE_CXX_EXTENSIONS OFF)

# Update module path
set(Viskores_CMAKE_MODULE_PATH ${Viskores_SOURCE_DIR}/CMake)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${Viskores_CMAKE_MODULE_PATH})

# While disabled system-wide, Viskores uses UNITY builds in some modules
set(CMAKE_UNITY_BUILD OFF)

# By default effectively disable unity builds
if (NOT DEFINED CMAKE_UNITY_BUILD_BATCH_SIZE)
  set(CMAKE_UNITY_BUILD_BATCH_SIZE 1)
endif()

# Determine Viskores version
include(Utilities/Git/Git.cmake)
include(ViskoresDetermineVersion)

# Load hardcoded version in case this is not a Git repository
file(STRINGS version.txt version_txt)
extract_version_components("${version_txt}" "Viskores")
# Get the version from git if we can
determine_version(${Viskores_SOURCE_DIR} ${GIT_EXECUTABLE} "Viskores")

if (NOT DEFINED Viskores_INSTALL_INCLUDE_DIR)
  set(Viskores_INSTALL_INCLUDE_DIR "include/viskores-${Viskores_VERSION_MAJOR}.${Viskores_VERSION_MINOR}")
endif()
if (NOT DEFINED Viskores_INSTALL_CONFIG_DIR)
  set(Viskores_INSTALL_CONFIG_DIR "lib/cmake/viskores-${Viskores_VERSION_MAJOR}.${Viskores_VERSION_MINOR}")
endif()
if (NOT DEFINED Viskores_INSTALL_LIB_DIR)
  set(Viskores_INSTALL_LIB_DIR "lib")
endif()
if (NOT DEFINED Viskores_INSTALL_BIN_DIR)
  set(Viskores_INSTALL_BIN_DIR "bin")
endif()
if (NOT DEFINED Viskores_INSTALL_SHARE_DIR)
  set(Viskores_INSTALL_SHARE_DIR "share/viskores-${Viskores_VERSION_MAJOR}.${Viskores_VERSION_MINOR}")
endif()
if (NOT DEFINED Viskores_INSTALL_CMAKE_MODULE_DIR)
  set(Viskores_INSTALL_CMAKE_MODULE_DIR "${Viskores_INSTALL_SHARE_DIR}/cmake")
endif()
if (NOT DEFINED Viskores_BUILD_CMAKE_BASE_DIR)
  set(Viskores_BUILD_CMAKE_BASE_DIR "${Viskores_BINARY_DIR}")
endif()
if(NOT DEFINED Viskores_EXECUTABLE_OUTPUT_PATH)
  ## Set the directory where the binaries will be stored
  set(Viskores_EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
endif()
if(NOT DEFINED Viskores_LIBRARY_OUTPUT_PATH)
  ## Set the directory where the libraries will be stored
  set(Viskores_LIBRARY_OUTPUT_PATH  ${PROJECT_BINARY_DIR}/lib)
endif()
if (NOT DEFINED Viskores_EXPORT_NAME)
  set(Viskores_EXPORT_NAME "ViskoresTargets")
endif()

set(Viskores_BINARY_INCLUDE_DIR "${Viskores_BINARY_DIR}/include")

#-----------------------------------------------------------------------------
# viskores_option(variable doc [initial])
#   Provides an option if it is not already defined.
# This can be replaced when CMake 3.13 is our cmake_minimum_required
macro (viskores_option variable)
  if (NOT DEFINED "${variable}")
    option("${variable}" ${ARGN})
  endif ()
endmacro ()

# Configurable Options
viskores_option(Viskores_ENABLE_CUDA "Enable Cuda support" OFF)
viskores_option(Viskores_ENABLE_KOKKOS "Enable Kokkos support" OFF)
viskores_option(Viskores_ENABLE_OPENMP "Enable OpenMP support" OFF)
viskores_option(Viskores_ENABLE_TBB "Enable TBB support" OFF)
viskores_option(Viskores_ENABLE_RENDERING "Enable rendering library" ON)
viskores_option(Viskores_ENABLE_BENCHMARKS "Enable Viskores Benchmarking" OFF)
viskores_option(Viskores_ENABLE_MPI "Enable MPI support" OFF)
viskores_option(Viskores_ENABLE_DOCUMENTATION "Build Doxygen documentation" OFF)
viskores_option(Viskores_ENABLE_EXAMPLES "Build examples" OFF)
viskores_option(Viskores_ENABLE_TUTORIALS "Build tutorials" OFF)
if (NOT DEFINED Viskores_ENABLE_TESTING)
    if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
      viskores_option(Viskores_ENABLE_TESTING "Enable Viskores Testing" ON)
    else()
      viskores_option(Viskores_ENABLE_TESTING "Enable Viskores Testing" OFF)
    endif()
endif()

# By default: (Viskores_ENABLE_TESTING OR Viskores_ENABLE_BENCHMARKS) -> Viskores_ENABLE_TESTING_LIBRARY
include(CMakeDependentOption)
cmake_dependent_option(Viskores_ENABLE_TESTING_LIBRARY "Enable Viskores Testing Library"
  OFF "NOT Viskores_ENABLE_TESTING;NOT Viskores_ENABLE_BENCHMARKS" ON)
mark_as_advanced(Viskores_ENABLE_TESTING_LIBRARY)

# The ANARI interop library uses a bit of code in viskores_rendering, so this option
# currently requires viskores_rendering to be built. Eventually this dependency
# should go away as viskores_anari doesn't require applications to use anything from
# viskores_rendering directly.
cmake_dependent_option(Viskores_ENABLE_ANARI "Enable ANARI interop support"
  OFF "Viskores_ENABLE_RENDERING" OFF)

# If you are building Doxygen, you also have the option to build the User's Guide with Sphinx
cmake_dependent_option(Viskores_ENABLE_USERS_GUIDE
  "Build User's Guide with Sphinx"
  ON
  "Viskores_ENABLE_DOCUMENTATION"
  OFF
  )
# If you are building the User's Guide, you may only need the XML output from Doxygen, which
# is much faster than generating the HTML. Thus, give the option to turn on/off the HTML output.
cmake_dependent_option(Viskores_Doxygen_HTML_output
  "Build HTML output"
  ON
  "Viskores_ENABLE_USERS_GUIDE"
  ON
  )
mark_as_advanced(Viskores_Doxygen_HTML_output)

# We may want to make finer controls on whether libraries/modules get built.
# VTK uses the concept of groups for its modules
viskores_option(Viskores_BUILD_ALL_LIBRARIES
  "Build all libraries by default. (Can be overridden for each library.)"
  ON
  )
mark_as_advanced(Viskores_BUILD_ALL_LIBRARIES)

viskores_option(Viskores_USE_DOUBLE_PRECISION "Use double precision for floating point calculations" OFF)
viskores_option(Viskores_USE_64BIT_IDS "Use 64-bit indices." ON)

viskores_option(Viskores_ENABLE_HDF5_IO "Enable HDF5 support" OFF)
if (Viskores_ENABLE_HDF5_IO)
  find_package(HDF5 REQUIRED COMPONENTS HL)
endif()

# If the linked HDF5 is parallel, we need to add the MPI include directory
# for its dependencies
viskores_option(Viskores_HDF5_IS_PARALLEL "HDF5 library is parallel" OFF)
mark_as_advanced(Viskores_HDF5_IS_PARALLEL)

# Viskores will turn on logging by default, but will set the default
# logging level to WARN.  This option should not be visible by default
# in the GUI, as ERROR and WARN level logging should not interfere
# with the performance of viskores
viskores_option(Viskores_ENABLE_LOGGING "Enable Viskores Logging" ON)

# When Viskores is embedded into larger projects they may desire to turn off
# Viskores internal assert checks when in debug mode to improve debug runtime
# performance.
viskores_option(Viskores_NO_ASSERT "Disable assertions in debugging builds." OFF)

# The CUDA compiler (as of CUDA 11) takes a surprising long time to compile
# kernels with assert in them. By default we turn off asserts when compiling
# for CUDA devices.
viskores_option(Viskores_NO_ASSERT_CUDA "Disable assertions for CUDA devices." ON)

# The HIP compiler (as of ROCm 3.7) takes a surprising long time to compile
# kernels with assert in them they generate `printf` calls which are very
# slow ( cause massive register spillage). By default we turn off asserts when
# compiling for HIP devices.
viskores_option(Viskores_NO_ASSERT_HIP "Disable assertions for HIP devices." ON)

# When Viskores is embedded into larger projects that wish to make end user
# applications they want to only install libraries and don't want CMake/headers
# installed.
viskores_option(Viskores_INSTALL_ONLY_LIBRARIES "install only viskores libraries and no headers" OFF)

# Install examples projects
cmake_dependent_option(Viskores_INSTALL_EXAMPLES "Install examples" OFF "NOT Viskores_ENABLE_EXAMPLES" ON)

# Viskores is setup by default not to export symbols unless explicitly stated.
# We prefer to only export symbols of a small set of user facing classes,
# rather than exporting all symbols. This flag is added so that consumers
# which require static builds can force all symbols on, which is something
# VTK does.
viskores_option(Viskores_HIDE_PRIVATE_SYMBOLS "Hide symbols from libraries." ON)

viskores_option(BUILD_SHARED_LIBS "Build Viskores with shared libraries" ON)
set(Viskores_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

# This flag can be used to prevent Viskores from exporting its warning flags in its
# build interface. This is useful when building Viskores as a thirdparty library
# and the warnings are too strict for the parent project.
viskores_option(Viskores_ENABLE_DEVELOPER_FLAGS "Enable compiler flags that are useful while developing Viskores" ON)

# By default Viskores would install its README.md and LICENSE.md.
# Some application might need not to install those, hence this option.
viskores_option(Viskores_NO_INSTALL_README_LICENSE "disable the installation of README and LICENSE files" OFF)

# In Python wheels, having SONAME suffixes just ends up duplicating files.
# Allow VTK to turn off these symlinks for its wheel distribution.
viskores_option(Viskores_SKIP_LIBRARY_VERSIONS "Skip versioning Viskores libraries" OFF)

# During development, running unit tests with the default values can be too lengthy.
# Allow for the developer to skip the majority of the default values and control them
# through ctest's command-line. Doesn't affect CI unless enabled.
viskores_option(Viskores_OVERRIDE_CTEST_TIMEOUT "Disable default ctest timeout" OFF)

# Viskores_ENABLE_GPU_MPI makes Viskores to use DIY routines that enables GPU aware
# MPI. By default, this option is disabled. Also, this option is hidden unless
# Viskores_ENABLE_MPI=ON.
cmake_dependent_option(Viskores_ENABLE_GPU_MPI "Enable GPU AWARE MPI support" OFF "Viskores_ENABLE_MPI" OFF)

mark_as_advanced(
  Viskores_ENABLE_LOGGING
  Viskores_NO_ASSERT
  Viskores_NO_ASSERT_CUDA
  Viskores_NO_ASSERT_HIP
  Viskores_INSTALL_ONLY_LIBRARIES
  Viskores_HIDE_PRIVATE_SYMBOLS
  Viskores_ENABLE_DEVELOPER_FLAGS
  Viskores_NO_INSTALL_README_LICENSE
  Viskores_SKIP_LIBRARY_VERSIONS
  Viskores_OVERRIDE_CTEST_TIMEOUT
  )

#-----------------------------------------------------------------------------
# Force building of modules where specified by user-facing options.
include(ViskoresModules)
viskores_module_force_group(Core VALUE "YES" REASON "Core modules always built")
viskores_module_force_group(Rendering ENABLE_OPTION Viskores_ENABLE_RENDERING)
viskores_module_force_group(Logging ENABLE_OPTION Viskores_ENABLE_LOGGING)
viskores_module_force_group(Testing
  ENABLE_OPTION Viskores_ENABLE_TESTING_LIBRARY
  ENABLE_VALUE "WANT"
  DISABLE_VALUE "DONT_WANT"
  )
viskores_module_force_group(Benchmarking ENABLE_OPTION Viskores_ENABLE_BENCHMARKS)
viskores_module_force_group(ANARI ENABLE_OPTION Viskores_ENABLE_ANARI)

# The tutorial requires several common filters. This logic might need to
# become more complicated (or less compliated if we decide to always
# compile these).
if(Viskores_ENABLE_TUTORIALS)
  viskores_module_force_group(FiltersCommon VALUE "YES" REASON "Tutorial needs common filters.")
endif()

#-----------------------------------------------------------------------------

# Setup default build types
include(ViskoresBuildType)

# Include the viskores wrappers
include(ViskoresWrappers)
